//----------------------------------------------
//--  Declare varaibles, shocks,  and parameter 
//----------------------------------------------
var 
//--- Endogenous state variables
Ce Ch N Ke Le Lh Be Y Ie Kg//10 endo quantities
Qh Qe Qk R //4 endo price
Muh Mue J M H
Mug1 Mug2 Mug3 Mug4 Mug5 Mug6 Mug7 Mug8 Mug9 Mug10 Mug11 Mug12 Mug13 Mug14//19
//--- 14 variables appearing in shock pricesses
Lambda_a Phi Psi Thetae Z Q L Ztr Qtr Ltr G Gz Ge Gl
//--- Additional variables and instruments variables
C I W Ig Tau 
//--- Observed data
DlogGDP DlogC DlogBe DlogI DlogIe DlogW1;

varexo Eps_phi 
Eps_l Eps_z  
Eps_gl Eps_gz
Eps_a Eps_e Eps_ge
Eps_psi 
Eps_xithetae
;

parameters
betaparam_trans  gltrans getrans inveta omegae omegag //gtrans
alpha thetae_bar delta gammaparam nu gammah gammae
n r qeleOqhlh tau chceOy
rho_phi rho_l rho_z rho_gl rho_gz rho_psi rho_xithetae
rho_a rho_e rho_ge
betaparam g ge gl lambda_abar chi eta
kgOy qeleOy qhlhOy phi keOy igOy ieOy beOy ceOy chOy
jy my muhy muey psi_bar phi_bar
mug1y mug2y mug3qh mug4Oy mug5Ole mug6y mug7y mug8 mug10Oy mug11Oy mug12 mug13y mug14y h kappa mug9 lh le 
;
//--- Persistence parameters
rho_phi=0.985210687157211;
rho_l=0.9;
rho_z=0.9;
rho_gl=0.9;
rho_gz=0.9;
rho_a=0.0;
rho_psi=0.9;
rho_xithetae=0.9;
rho_ge=0.9;
rho_e=0.9;
//--- Deep parameters 
betaparam_trans=0.25; 
lambda_abar=0.01;
//gtrans=1.2; 
getrans=0.175; 
gltrans=1.5; 
inveta=3;
omegae =0.0;
omegag=0.0;
//--- Targeted steady state values
gammah=0.498681215593994;
gammae=0.657785431846753;
delta = 0.03; 
alpha = 0.5; 
thetae_bar = 0.5; 
tau=0.055; 
gammaparam=0.6;
nu=2/3;
n = 1/4; 
r=1.015;
qeleOqhlh=0.2;
chceOy=0.4;
//--------------------------------------------------------------------
//-- Model specification
//--------------------------------------------------------------------
model(linear);
//(0)
J = - Ch/(1-gammah/g) + gammah/(g*(1-gammah/g))*(Ch(-1) - G);
M = - Ce/(1-gammae/g) + gammae/(g*(1-gammae/g))*(Ce(-1) - G);

//(0.5)
muhy*Muh = jy*J - betaparam*(1+lambda_abar)*gammah*jy*(J(+1) - G(+1))/g - betaparam*lambda_abar*gammah*jy*Lambda_a(+1)/g;

//(1)
Qh + Muh = (betaparam*(1+lambda_abar)/gl)*(Qh(+1) + Muh(+1)  - Gl(+1)) 
+ (betaparam*lambda_abar/gl) *Lambda_a(+1) + (1-betaparam*(1+lambda_abar)/gl)*(Phi - Lh);

//(2)
Psi - Muh + eta*N = Y - N - tau*Tau/(1-tau);

//(3)
R = -Muh(+1) + G(+1) + Muh - lambda_abar*Lambda_a(+1)/(1+lambda_abar);

//(4.0)
muey*Mue = my*M - betaparam*gammae*my*(M(+1) - G(+1))/g;

//(4) 
Qk + Mue = betaparam*(1-phi)*alpha*(1-tau)*(Y(+1) + Mue(+1) - Ke - tau*Tau(+1)/(1-tau))/keOy
+ thetae_bar*(Thetae - R + Mue - Ge(+1) + Qk(+1))/(r*ge) - betaparam*(1-delta-thetae_bar)*(-Mue(+1) + G(+1) + Ge(+1) - Qk(+1))/(g*ge)
- betaparam*thetae_bar*Thetae/(g*ge);

//(5)
Qe + Mue = betaparam*phi*alpha*(1-tau)*(Y(+1)  + Mue(+1) - Le - tau*Tau(+1)/(1-tau))/qeleOy
+ thetae_bar*g*(Thetae + G(+1) + Qe(+1) - R + Mue - Gl(+1))/(r*gl)
+ betaparam*(1-thetae_bar)*(Qe(+1) + Mue(+1) - Gl(+1))/gl - betaparam*thetae_bar*Thetae/gl;

//(6)
alpha*(1-tau)*Y - alpha*tau*Tau = ceOy*Ce + ieOy*Ie + qeleOy*(Qe +Le) - qeleOy*(Qe + Le(-1) - Gl)/gl
 + ((1/g)*beOy)*(Be(-1) - G) - ((1/r)*beOy)*(Be - R);

//(7)
Ke = ((1-delta)/(g*ge))*(Ke(-1) - G - Ge) + (1 - (1-delta)/(g*ge))*Ie;

//(8)
Kg = ((1-delta)/g)*(Kg(-1) - G) + (1 - (1-delta)/g)*Ig;

//(9)
Be = Thetae + (g*thetae_bar*qeleOy/(beOy*gl))*(Qe(+1) + Le + G(+1) - Gl(+1)) 
+ (thetae_bar*keOy/(ge*beOy))*( Qk(+1) + Ke - Ge(+1)); 

//(10)
Y = -(kappa+alpha*(1-phi))*G - alpha*phi*Gl - alpha*(1-phi)*Ge + alpha*phi*Le(-1) + alpha*(1-phi)*Ke(-1) + (1-alpha)*N + kappa*Kg(-1);

//(11)
tau*(Y + Tau) + qhlhOy*(Qh + Lh) - (qhlhOy/gl)*(Qh + Lh(-1) - Gl)
+ qeleOy*(Qe + Le) - (qeleOy/gl)*(Qe + Le(-1) - Gl) = igOy*Ig;
//Qh =Qe;

//(12)
0 = lh*Lh + le*Le;

//(13)
chOy*Ch + ceOy*Ce + ieOy*Ie + igOy*Ig = Y;

//(13.1)
Qk - omegae*(g*ge)^2*(Ie - Ie(-1) + G + Ge) + betaparam*omegae*(g*ge)^2*(Ie(+1) - Ie+ G(+1) + Ge(+1))=0;

//(14)
//gammaparam*nu*jy*J - gammaparam*nu*betaparam*(1-chi)*gammah*jy*(J(+1) - G(+1))/g - mug7y*Mug7
//+ mug10Oy*jy^2*(Mug10 + 2*J) + betaparam*(1 + lambda_abar)*gammah^2*mug10Oy*jy^2*(Mug10 + 2*J(+1) - 2*G(+1))/(g^2) 
//+ betaparam*lambda_abar*gammah^2*mug10Oy*jy^2*Lambda_a(+1)/(g^2)
//- (1+lambda_abar)*gammah*jy^2*mug10Oy*(2*J - G + Mug10(-1))/((1-chi)*g) - lambda_abar*gammah*jy^2*mug10Oy*Lambda_a/((1-chi)*g)
//- betaparam*(1-chi)*gammah*mug10Oy*jy^2*(2*J(+1) - G(+1) +Mug10(+1))/g= 0;

gammaparam*nu*jy*J - gammaparam*nu*betaparam*(1 - chi)*gammah*jy*(J(+1) - G(+1))/g - mug7y*Mug7
+ mug10Oy*jy^2*(Mug10 + 2*J) + betaparam*(1 + lambda_abar)*gammah^2*jy^2*mug10Oy*(Mug10 + 2*J(+1) - 2*G(+1))/(g^2)
+ betaparam*lambda_abar*gammah^2*jy^2*mug10Oy*Lambda_a(+1)/(g^2)
- (1 + lambda_abar)*gammah*jy^2*mug10Oy*(2*J - G + Mug10(-1))/((1-chi)*g) - lambda_abar*gammah*jy^2*mug10Oy*Lambda_a/((1-chi)*g)
-betaparam*(1-chi)*gammah*mug10Oy*jy^2*(2*J(+1) - G(+1) + Mug10(+1))/g = 0;

//(15)
(1-gammaparam)*nu*my*M - (1-gammaparam)*nu*betaparam*(1-chi)*gammae*my*(M(+1) - G(+1))/g - mug2y*Mug2 - mug7y*Mug7
+ mug11Oy*my^2*(Mug11 + 2*M) + betaparam*gammae^2*mug11Oy*my^2*(Mug11 + 2*M(+1) - 2*G(+1))/(g^2) 
- gammae*my^2*mug11Oy*(2*M - G + Mug11(-1))/((1-chi)*g)
- betaparam*(1-chi)*gammae*mug11Oy*my^2*(2*M(+1) - G(+1) +Mug11(+1))/g= 0;

//(1-gammaparam)*nu*my*M - betaparam*(1-chi)*(1-gammaparam)*nu*gammae*my*(M(+1) - G(+1))/g - mug2y*Mug2 - mug7y*Mug7
//+mug11Oy*my^2*(Mug11 + 2*M) + gammae^2*betaparam*mug11Oy*my^2*(Mug11 + 2*M(+1) - 2*G(+1))/(g^2)
//- gammae*mug11Oy*my^2*(Mug11(-1) + 2*M - G)/((1-chi)*g) 
//- betaparam*(1-chi)*gammae*mug11Oy*my^2*(Mug11(+1) +2*M(+1) - G(+1))/g=0;

//(16)
nu*gammaparam*phi_bar*(Phi - Lh) + qhlhOy*mug1y*(Mug1 + Qh) - (betaparam*(1-chi)*qhlhOy*mug1y/gl)*(Mug1(+1) + Qh(+1) - Gl(+1))
+ (phi_bar*mug3qh/(muhy*qhlhOy))*(Phi - Muh + Mug3 - 2*Lh) = lh*mug9*Mug9;

//(17)
h*(H - Y) = betaparam*(1-chi)*tau*mug1y*(Mug1 + Tau) + betaparam*(1-chi)*(1-tau)*alpha*mug2y*(Mug2 - tau*Tau/(1-tau))
+ (betaparam*alpha*(1-phi)*(1-tau)*mug4Oy*muey/(keOy))*(Mug4(-1) + Mue - Ke(-1) - tau*Tau/(1-tau))
+ (betaparam*alpha*phi*(1-tau)*mug5Ole*muey)*(Mug5(-1) + Mue- Le(-1) - tau*Tau/(1-tau))
+ (betaparam*(1-chi)*(1-tau)*(1-alpha)*mug6y/n)*(Mug6 -N- tau*Tau/(1-tau)) + betaparam*(1-chi)*mug7y*Mug7;

//(18)
qeleOy*mug1y*(Mug1 + Qe) - (betaparam*(1-chi)*qeleOy*mug1y/gl)*(Mug1(+1) + Qe(+1) - Gl(+1)) 
+ (thetae_bar*g*qeleOy*mug2y/(r*gl))*(Mug2 + Thetae + Qe(+1) +G(+1) - R - Gl(+1)) - qeleOy*mug2y*(Mug2 + Qe)
+(betaparam*(1-chi)*(1-thetae_bar)*qeleOy*mug2y/gl)*(Mug2(+1) + Qe(+1) -Gl(+1) -thetae_bar*Thetae/(1-thetae_bar))
- (betaparam*alpha*phi*(1-tau)*mug5Ole*muey)*(Y(+1) + Mue(+1) + Mug5- 2*Le - tau*Tau(+1)/(1-tau)) + alpha*phi*h*(H(+1)-Le)=le*mug9*Mug9;

//(19)
 - mug14y*Mug14 + (betaparam*(1-chi)*(1-delta)*mug14y/g)*(Mug14(+1) - G(+1)) 
+ kappa*h*(H(+1) - Kg) /kgOy= 0;

//(20)
- (nu*gammaparam*psi_bar*n^eta)*(Psi + eta*N) - ((1-alpha)*(1-tau)*mug6y/(n^2))*(Y + Mug6 - 2*N - tau*Tau/(1-tau)) 
- (psi_bar*eta*n^(eta-1)*mug6y/(muhy))*(Psi - Muh + Mug6 + (eta-1)*N) + ((1-alpha)*h/(betaparam*(1-chi)*n))*(H-N)=0;

//(21)
(thetae_bar*mug2y/(r*ge))*(Mug2 + Thetae - R - Ge(+1) + Qk(+1)) - (betaparam*(1-chi)*thetae_bar*mug2y/(g*ge))*(Mug2(+1) - G(+1) - Ge(+1) +Thetae +Qk(+1))
 - mug13y*Mug13 + (betaparam*(1-chi)*(1-delta)*mug13y/(g*ge))*(Mug13(+1) - G(+1) - Ge(+1)) 
+ (alpha*(1-phi)*h/keOy)*(H(+1) - Ke) - (betaparam*alpha*(1-phi)*(1-tau)*mug4Oy*muey/(keOy^2))*(Y(+1) + Mug4 + Mue(+1) - 2*Ke - tau*Tau(+1)/(1-tau)) =0;

//(22)
h*(H - Y) = betaparam*(1-chi)*(mug1y*Mug1 + mug7y*Mug7);

//(23)
qhlhOy*mug1y*(Mug1 + Lh) - (qhlhOy*mug1y/gl)*(Mug1 + Lh(-1) - Gl) + mug3qh*Mug3 - (mug3qh*g/(betaparam*(1-chi)*r*gl))*(Mug3(-1) + G - R(-1) - Gl)=0;

//(24)
mug1y*(Mug1 + Le) - (mug1y/gl)*(Mug1 + Le(-1) - Gl) - mug2y*(Mug2 + Le) + ((1-thetae_bar)*mug2y/gl)*(Mug2 + Le(-1) - Gl - thetae_bar*Thetae(-1)/(1-thetae_bar))
+ (thetae_bar*g*mug2y/(betaparam*(1-chi)*r*gl))*(Thetae(-1) + Mug2(-1) + Le(-1) + G - R(-1) - Gl) - (mug5Ole*muey)*(Mug5 + Mue)
+ ((1-thetae_bar)*mug5Ole*muey/((1-chi)*gl))*(Mug5(-1) - Gl + Mue - thetae_bar*Thetae(-1)/(1-thetae_bar))
+ (thetae_bar*g*mug5Ole*muey/(betaparam*(1-chi)*gl*r))*(Thetae(-1) + G + Mug5(-1) - R(-1) + Mue(-1) - Gl)=0;

//(25)
beOy*mug2y*(Mug2 + Be) - (g*mug3qh/gl)*(Mug3 + Qh(+1) + G(+1) - Gl(+1)) + (thetae_bar*mug4Oy*muey/(ge))*(Thetae + Mug4 + Mue - Ge(+1))
+ (thetae_bar*g*mug5Ole*qeleOy*muey/(gl))*(Mug5 + Qe(+1) + G(+1) + Thetae - Gl(+1) + Mue) + mug8*Mug8=0;

//(26)
phi_bar*mug3qh*(Phi - Muh - Lh + Mug3)/(muhy*qhlhOy) + psi_bar*(n^eta)*mug6y*(Psi - Muh + Mug6 + eta*N)/(muhy)
+ mug8*(Mug8 - R)/r - mug8*(Mug8(-1) - R(-1))/(betaparam*(1-chi)*r) + mug10Oy*muhy*(Mug10 + Muh) = 0;


//(27)
(thetae_bar*mug4Oy*muey/(r*ge))*(Mug4 + Mue - Ge(+1) + Thetae - R + Qk(+1) -(Mug4(-1) + Mue(-1) - Ge + Thetae(-1) - R(-1) + Qk)/(betaparam*(1-chi)))
+ (thetae_bar*g*qeleOy*mug5Ole*muey/(r*gl))*(Thetae + G(+1) + Qe(+1) + Mug5 - Gl(+1) - R + Mue - (Thetae(-1) + G + Qe + Mug5(-1) - Gl - R(-1) + Mue(-1))/(betaparam*(1-chi)))
- (mug4Oy*muey)*(Mug4 + Mue + Qk - (Mug4(-1) + Mue(-1) + Qk(-1))/(betaparam*(1-chi)))
- (qeleOy*mug5Ole*muey)*(Qe + Mug5 + Mue - (Qe(-1) + Mug5(-1) + Mue(-1))/(betaparam*(1-chi))) + mug11Oy*muey*(Mug11 + Mue)
- mug12*betaparam*omegae*g^2*ge^2*(Ie(+1) + G(+1) +Ge(+1) - Ie) + mug12*omegae*g^2*ge^2*(Ie + G +Ge - Ie(-1))/(1-chi)=0;

//mug4Oy*muey*thetae_bar*(Mug4 + Mue + Thetae -R - Ge(+1))/(r*ge) - mug4Oy*muey*(Mug4 + Mue)
//-(mug4Oy*muey*thetae_bar*(Mug4(-1) + Mue(-1) + Thetae(-1) -R(-1) - Ge)/(r*ge) - mug4Oy*muey*(Mug4(-1) + Mue(-1)))/(betaparam*(1-chi))
//+ mug5Ole*muey*qeleOy*thetae_bar*g*(Mug5 + Mue + Thetae - R + G(+1) - Gl(+1) + Qe(+1))/(r*gl) - mug5Ole*muey*qeleOy*(Mug5 + Mue + Qe)
//- (mug5Ole*muey*qeleOy*thetae_bar*g*(Mug5(-1) + Mue(-1) + Thetae(-1) - R(-1) + G - Gl + Qe)/(r*gl) - mug5Ole*muey*qeleOy*(Mug5(-1) + Mue(-1) + Qe(-1)))/(betaparam*(1-chi))
//+ mug11Oy*muey*(Mug11 + Mue)=0;

//(28)
 - mug2y*keOy*thetae_bar*(Mug2 + Ke(-1) + Thetae(-1) - G - Ge)/(g*ge)
+ thetae_bar*mug2y*keOy*(Mug2(-1) + Ke(-1) + Thetae(-1) -R(-1) - Ge)/(betaparam*(1-chi)*r*ge)
+ (1-delta-thetae_bar)*muey*mug4Oy*(Mug4(-1) + Mue - Ge - G - thetae_bar*Thetae(-1)/(1-delta-thetae_bar))/((1-chi)*g*ge)
+ thetae_bar*muey*mug4Oy*(Mug4(-1) + Mue(-1) +Thetae(-1) - R(-1) - Ge)/(betaparam*(1-chi)*r*ge) - muey*mug4Oy*(Mug4 + Mue)
+ mug12*Mug12 - omegae*mug12*(g*ge)^2*(Ie - Ie(-1) +G + Ge) + omegae*(1+lambda_abar)*mug12*(g*ge)^2*(Ie - Ie(-1) + G + Ge)/(1-chi)=0;

//(29)
-omegae*g*ge*mug12*(Mug12 + Qk + Ie + G + Ge - 2*Ie(-1)) - 2*omegae*g*ge*mug12*(Ie - Ie(-1) + G + Ge)
+ betaparam*(1-chi)*omegae*g*ge*mug12*(Mug12(+1) + Qk(+1) + 2*Ie(+1) - 3*Ie + 2*G(+1) +2*Ge(+1) - G - Ge)
+ 2*betaparam*(1-chi)*omegae*g*ge*mug12*(Ie(+1) - Ie + G(+1) + Ge(+1))
- betaparam*omegae*g*ge*mug12*(Mug12 + Qk(+1) + Mue(+1) - Mue + 3*Ie(+1) - 4*Ie + 2*G(+1) +2*Ge(+1) - G - Ge)
- 2*betaparam*omegae*g*ge*mug12*(Ie(+1) - Ie + G(+1) + Ge(+1))
+ (1/(1-chi))*omegae*g*ge*mug12*(Mug12(-1) + Qk + Mue - Mue(-1) + Ie(+1) - 2*Ie(-1)  + G + Ge)
+ 2*(1/(1-chi))*omegae*g*ge*mug12*(Ie - Ie(-1) + G + Ge)
- mug7y*ieOy*(Mug7 - G - Ge)/(g*ge) - mug2y*ieOy*(Mug2 - G - Ge)/(g*ge)  + mug13y*ieOy*(Mug13 - G - Ge)/(g*ge) - omegae*mug13y*ieOy*g*ge*(Ie - Ie(-1) + G + Ge)
+ betaparam*(1-chi)*omegae*g*ge*mug13y*ieOy*(Ie(+1) - Ie + G(+1) + Ge(+1))=0;

//(30)
- (1-nu)*Ig/igOy - mug1y*Mug1 - mug7y*Mug7 + mug14y*Mug14 - mug14y*omegag*g^2*(Ig + G - Ig(-1)) + betaparam*(1-chi)*mug14y*omegag*g^2*(Ig(+1) + G(+1) - Ig)=0;

C = (chOy/(chOy+ceOy))*Ch + (ceOy/(chOy+ceOy))*Ce;
I = (igOy/(igOy+ieOy))*Ig + (ieOy/(igOy+ieOy))*Ie;
W = Y - N - tau*Tau/(1-tau);

Phi = rho_phi*Phi(-1)+Eps_phi; 
Gz = Z + Ztr - Ztr(-1);
Gl = L + Ltr - Ltr(-1);
Ge =Q + Qtr - Qtr(-1);
G = (1/(1-(1-phi)*alpha-kappa))*(Gz + alpha*phi*Gl + (1-phi)*alpha*Ge);
Z = rho_gz*Z(-1) + Eps_gz; 
Ztr = rho_z*Ztr(-1) + Eps_z;
L = rho_gl*L(-1) + Eps_gl;
Ltr = rho_l*Ltr(-1) + Eps_l;
Q = rho_ge*Q(-1) + Eps_ge;
Qtr=rho_e*Qtr(-1) + Eps_e;

Lambda_a = rho_a*Lambda_a(-1) + Eps_a;
Psi = rho_psi*Psi(-1) + Eps_psi;
Thetae=rho_xithetae*Thetae(-1) + Eps_xithetae;

DlogC = (C - C(-1) + log(g) + G);
DlogI = (I - I(-1) + log(g) + G);
DlogGDP = (Y - Y(-1) + log(g) + G);
DlogBe = (Be - Be(-1) + log(g) + G);
DlogIe = (Ie - Ie(-1) + log(g) + G);
DlogW1 = (W - W(-1) + log(g) +G);
end;

steady;
check;

shocks;
var Eps_phi; stderr   0.297431536629000;
var Eps_z; stderr 0.0; 
var Eps_l; stderr 0.0; 
var Eps_gl; stderr 0.1; 
var Eps_gz; stderr 0.1; 
var Eps_a; stderr 0.0; 
var Eps_psi; stderr 0.0; 
var Eps_xithetae; stderr 0.0; 
var Eps_ge; stderr 0.0; 
var Eps_e; stderr 0.0; 


end;


//--------------------------------------------------------------------
//-- Estimation
//--------------------------------------------------------------------
varobs 
DlogC 
DlogI 
DlogBe 
DlogGDP 
DlogW1 
DlogIe 
;


estimated_params;
// PARAM NAME, INITVAL, LB, UB, PRIOR_SHAPE, PRIOR_P1, PRIOR_P2, PRIOR_P3, PRIOR_P4, JSCALE
// PRIOR_SHAPE: BETA_PDF, GAMMA_PDF, NORMAL_PDF, INV_GAMMA_PDF
stderr Eps_z,0.0037,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_l,0.01,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_gz,0.0042,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_gl,0.01,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_phi,0.0462,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
//stderr Eps_a,0.1013,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_psi,0.0073,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
stderr Eps_xithetae,0.0112,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
//stderr Eps_e,0.0073,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
//stderr Eps_ge,0.0112,0.000000000001,100,INV_GAMMA2_PDF,0.1,2;
//gtrans, ,.00001,10,GAMMA_PDF,2.3,0.25;
gltrans, ,.00001,10,GAMMA_PDF,1.25,0.5;
//getrans, ,.00001,10,GAMMA_PDF,0.175,0.05;
betaparam_trans, ,.00001,10,GAMMA_PDF,0.25,0.10;
lambda_abar, ,0.000000001, 0.1, BETA_PDF, 0.01,0.05;
gammah, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
gammae, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
inveta, ,.00001,10,NORMAL_PDF,2,0.75;
//omegae, , 0.000001,10,GAMMA_PDF,2,2;
//omegag, , 0.000001,10,GAMMA_PDF,2,2;
gammaparam, ,.00001,0.99999999,BETA_PDF,0.5,0.1;
nu, ,.00001,0.99999999,BETA_PDF,2/3,0.1;
rho_z, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_l, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_gz, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_gl, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_phi, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
//rho_a, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_psi, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
rho_xithetae, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
//rho_e, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
//rho_ge, ,.00000001,.99999999999,BETA_PDF,0.333333333333333,0.235702260395516;
end;
options_.blockinds = [ones(8,1) ; 2*ones(5,1) ; 3*ones(8,1)];
options_.Harvey_scale_factor = 10; //100;

estimated_params_init;
//   gtrans, 2.3; 
   gltrans, 1.5; 
   //getrans, 0.175;
   betaparam_trans, 0.25;
   lambda_abar, 0.01;
   gammah, 0.4976;
   gammae, 0.6584;
   inveta, 3;
   //omegae, 0.1753;
   //omegag, 0.1753;
   gammaparam, 0.6; 
   nu, 2/3;
   rho_z, 0.2;	 
   rho_l, 0.1;
   //rho_e, 0.2949;
   rho_gz, 0.4263;	 
   rho_gl, 0.4263;	 
   //rho_ge, 0.5620;
   rho_phi, 0.99;	 
   //rho_a, 0.9055;	 
   rho_psi, 0.9;	 
   rho_xithetae, 0.9;	 
   //
   stderr Eps_z, 0.0037;   
   stderr Eps_l, 0.0037;
   stderr Eps_gz, 0.0042; 
   stderr Eps_gl, 0.0042;
   stderr Eps_phi, 0.1;
   //stderr Eps_a, 0.0513;
   stderr Eps_psi, 0.0073;  
   stderr Eps_xithetae, 0.0112;
   //stderr Eps_e, 0.0029;  
   //stderr Eps_ge, 0.0042;
end;

options_.nit = 100000;  //Max number of iterations; Default 1000
options_.prior_trunc = 0;
options_.crit = 1e-7;   //Adjusts convergence criteion; Default 1e-07.
options_.gradient_epsilon = 1E-06; %differentiation increment;
options_.gradient_method = 2;  //2,3,or 5 point formula used to compute gradient;  Default = 2.
options_.gradient_epsilon = 1E-06;  //differentiation increment; Default 1e-06.
//estimation(datafile=data_bys,mode_check,mode_compute=9,lik_init=2,mh_replic=0,mh_nblocks=2,presample = 0,mh_jscale=0.20,mh_drop=0.2,optim=('Display','iter','MaxFunEvals',15000,'MaxIter',50000),smoother,forecast=20)DlogC  DlogI  DlogBe  DlogGDP;
estimation(datafile=data_bys,mode_check,mode_compute=9,lik_init=2,bayesian_irf,mh_conf_sig = 0.68,mh_nblocks=2,presample = 3,mh_jscale=0.20,mh_drop=0.2,mcmc_jumping_covariance = hessian,optim=('Display','iter','MaxFunEvals',15000),smoother,forecast=20)DlogC  DlogI  DlogBe  DlogGDP Y C Qe Qh Ie Ig N Tau Gz Gl G;

stoch_simul(irf=40, conditional_variance_decomposition=[1 4 8 16 24 32]) Y C Qe Qh Ie Ig N Tau Gz Gl G; 


