function [ys,check] = solveLFSS(ys,exo)

global M_ 
global betaparam_trans lambda_abar gltrans getrans alpha thetae_bar delta gammaparam nu gammah gammae n r qeleOqhlh tau chceOy inveta omegae omegag
global betaparam g ge gl  chi eta kgOy qeleOy qhlhOy phi keOy igOy ieOy beOy ceOy chOy jy my muhy muey psi_bar phi_bar mug1y mug2y mug3qh mug4Oy mug5Ole mug6y mug7y mug8 mug10Oy mug11Oy mug12 mug13y mug14y h kappa mug9 lh le

% read out parameters to access them with their name
NumberOfParameters = M_.param_nbr;
for ii = 1:NumberOfParameters
  paramname = deblank(M_.param_names(ii,:));
  eval([ paramname ' = M_.params(' int2str(ii) ');']);
end
% initialize indicator
check = 0;

%% Enter model equations here
betaparame = 1/(betaparam_trans/100+1); % p10.1 begins
betaparam = betaparame/(1+lambda_abar);
g =betaparame*r;
ge = getrans/100 + 1;
gl = gltrans/100 + 1;
chi = -lambda_abar; 
eta = 1/inveta;

AA=1/((1-1/gl)*(1+1/qeleOqhlh)); BB=(1-betaparam*(1+lambda_abar*thetae_bar)/gl)/(betaparam*alpha*(1-tau));
CC=betaparam*alpha*(1-tau)/(1-betaparam*(1-delta+lambda_abar*thetae_bar)/(ge*g));
DD=(1-(1-delta)/(ge*g));
igOy=(1-chceOy-DD*CC*(BB*tau+1))/(1-AA*BB*CC*DD);

kgOy = igOy/(1-(1-delta)/(g));
qeleOy = (igOy-tau)/((1-1/gl)*(1+1/qeleOqhlh));
qhlhOy = qeleOy/qeleOqhlh;
phi = qeleOy*(1-betaparam*(1+lambda_abar*thetae_bar)/gl)/(betaparam*alpha*(1-tau));
keOy = betaparam*(1-phi)*alpha*(1-tau)/(1-betaparam*(1-delta+lambda_abar*thetae_bar)/(ge*g));

ieOy = keOy*(1-(1-delta)/(ge*g));
beOy = thetae_bar*(qeleOy*g/gl+keOy/ge);
ceOy = alpha*(1-tau)-ieOy-qeleOy*(1-1/gl)-(1/g-1/r)*beOy;
chOy = 1-ieOy-igOy-ceOy; % p10.1 end

jy = 1/(chOy*(1-gammah/g)); %p22 begin
my = 1/(ceOy*(1-gammae/g));
muhy = jy*(1-betaparam*(1+lambda_abar)*gammah/g);
muey = my*(1-betaparam*gammae/g);
phi_bar = qhlhOy*muhy*(1-g/(gl*r)); % p22 end
psi_bar = (1-tau)*(1-alpha)*muhy*n^(-1-eta); % p31

A17 = -1; A110 = jy^2*(1 + betaparam*(1+lambda_abar)*gammah^2/(g^2) - (1+lambda_abar)*gammah/(g*(1-chi)) - betaparam*(1-chi)*gammah/g); B1 = -nu*gammaparam*(1-betaparam*(1-chi)*gammah/g)*jy; % p22 Ch
A22 = -1; A27 = -1; A211 = my^2*(1 + betaparam*gammae^2/(g^2) - gammae/(g*(1-chi)) - betaparam*(1-chi)*gammae/g); B2 = -nu*(1-gammaparam)*(1-betaparam*(1-chi)*gammae/g)*my; % p22 Ce
A31 = betaparam*(1-chi)*tau; A32 = betaparam*(1-chi)*(1-tau)*alpha; A34 = betaparam*alpha*(1-phi)*(1-tau)*muey/keOy; A35 = betaparam*alpha*phi*(1-tau)*muey; A36 = betaparam*(1-chi)*(1-tau)*(1-alpha)/n; A37 = betaparam*(1-chi); A39 = -1; %p11 H
A46 = -((1-alpha)*(1-tau)/(n^2) + eta*psi_bar*n^(eta-1)/muhy); A49 =(1-alpha)/(betaparam*(1-chi)*n); B4 = psi_bar*nu*gammaparam*n^eta; %p31 N
A52 = thetae_bar/(r*ge) - betaparam*(1-chi)*thetae_bar/(g*ge); A54 = -betaparam*alpha*(1-phi)*(1-tau)*muey/(keOy^2); A59 = alpha*(1-phi)/keOy; A513 = betaparam*(1-chi)*(1-delta)/(g*ge)-1;%p37 Ke
A61 = betaparam*(1-chi); A67 = betaparam*(1-chi); A69 = -1; %p12 Tau
A71 = (1-1/gl)*qeleOy; A72 = ((1-thetae_bar)/gl + thetae_bar*g/(betaparam*(1-chi)*r*gl) - 1)*qeleOy; A75 =  ((1-thetae_bar)/((1-chi)*gl) + thetae_bar*g/(betaparam*(1-chi)*r*gl) - 1)*qeleOy*muey; %p12 Qe
A82 = beOy; A83 = -g/gl; A84 = thetae_bar*muey/(ge); A85 = thetae_bar*g*qeleOy*muey/(gl); A88 = 1; %p12 R
A91 = (1-1/gl)*qhlhOy; A93 = 1 - g/(betaparam*(1-chi)*r*gl);%p12 Qh
A103 = phi_bar/(muhy*qhlhOy); A106 = psi_bar*n^eta/muhy; A108 = (1-1/(betaparam*(1-chi)))/r; A1010 = muhy; %p22 Muh & p31
A114 = (1-1/(betaparam*(1-chi)))*(thetae_bar/(ge*r)-1); A115 = (1-1/(betaparam*(1-chi)))*(thetae_bar*g/(gl*r)-1)*qeleOy; A1111 = 1; %p22 Mue
A122 = thetae_bar*keOy/(betaparam*(1-chi)*r*ge) - thetae_bar*keOy/(g*ge); A124 = ((betaparam*(1-delta-thetae_bar)/g+thetae_bar/r)/(betaparam*(1-chi)*ge)-1)*muey; A1212=1; % p37 Qk 
A132 = - ieOy/(g*ge); A137 = - ieOy/(g*ge); A1312 = (-1 - betaparam*chi + 1/(1-chi))*omegae*g*ge; A1313 = ieOy/(g*ge); % p37 Ie
A141 = -1; A147 = -1; A1414 = 1; B14= -(1-nu)/igOy; % p37 Ig



A=[0        0           0            0             0           0          A17    0        0        A110    0          0           0          0; ...
      0        A22      0            0              0           0          A27   0         0        0           A211   0           0          0; ...
      A31   A32      0           A34         A35      A36      A37    0        A39   0           0           0           0          0; ...
      0        0           0           0              0           A46     0         0         A49   0           0          0           0          0; ...
      0        A52      0           A54         0           0          0         0         A59   0           0          0           A513    0; ...
      A61   0           0           0              0           0          A67    0         A69   0           0          0           0          0; ...
      A71   A72      0           0              A75      0          0         0         0        0           0          0           0          0; ...
      0        A82      A83      A84         A85      0          0         A88    0        0           0          0            0          0; ...
      A91   0           A93      0              0           0          0         0         0        0           0          0           0          0; ...
      0        0           A103    0              0           A106   0         A108  0        A1010  0          0           0          0;...
      0        0           0           A114       A115    0          0         0         0        0           A1111 0           0          0; ...
      0        A122    0           A124       0           0          0         0         0        0           0          A1212  0          0; ...
      0        A132    0           0              0           0          A137  0         0        0           0          A1312  A1313 0; ...
      A141 0           0           0              0           0          A147  0         0        0           0          0           0          A1414];
B=[B1;B2;0;B4;0;0;0;0;0;0;0;0;0;B14];
x=inv(A)*B;
mug1y=x(1);mug2y=x(2);mug3qh=x(3);mug4Oy=x(4);mug5Ole=x(5);mug6y=x(6);mug7y=x(7);mug8=x(8);h=x(9);mug10Oy=x(10);mug11Oy=x(11); mug12=x(12); mug13y=x(13); mug14y=x(14);

kappa = (1 - betaparam*(1-chi)*(1-delta)/g)*mug14y*kgOy/h; %p37 Kg
mug9 = gammaparam*nu*phi_bar + (1-betaparam*(1-chi)/gl)*(qeleOy+qhlhOy)*mug1y + (thetae_bar*g/(r*gl)-1+betaparam*(1-chi)*(1-thetae_bar)/gl)*qeleOy*mug2y + phi_bar*mug3qh/(muhy*qhlhOy) - betaparam*alpha*phi*(1-tau)*mug5Ole*muey+ alpha*phi*h; %p11 Lh+Le
lh = (gammaparam*nu*phi_bar + (1-betaparam*(1-chi)/gl)*qhlhOy*mug1y + phi_bar*mug3qh/(muhy*qhlhOy))/mug9; %p11 Lh
le = ((1-betaparam*(1-chi)/gl)*qeleOy*mug1y + (thetae_bar*g/(r*gl)-1+betaparam*(1-chi)*(1-thetae_bar)/gl)*qeleOy*mug2y - betaparam*alpha*phi*(1-tau)*mug5Ole*muey + alpha*phi*h)/mug9; %p11 Le
%%
Ch=0; Ce=0; N=0; Ke=0; Le=0; Lh=0; Be=0; Y=0; Ie=0; Kg=0;
Qh=0; Qe=0; R=0; Qk =0; Muh=0; Mue=0; J=0; M=0; H=0;
Mug1=0; Mug2=0; Mug3=0; Mug4=0; Mug5=0; Mug6=0; Mug7=0; Mug8=0; Mug9=0; Mug10=0; Mug11=0; Mug12 = 0; Mug13=0; Mug14=0;
Lambda_a=0; Phi=0; Psi=0; Thetae=0; Z=0; Q=0; L=0; Ztr=0; Qtr=0; Ltr=0; G=0; Gz=0; Ge=0; Gl=0;
C=0; I=0; W=0; Ig=0; Tau=0; DlogGDP=log(g); DlogC=log(g); DlogBe=log(g); DlogI=log(g); DlogIe=log(g); DlogW1=log(g);
%% end own model equations

for iter = 1:length(M_.params) %update parameters set in the file
  eval([ 'M_.params(' num2str(iter) ') = ' M_.param_names(iter,:) ';' ])
end
NumberOfEndogenousVariables = M_.orig_endo_nbr; %auxiliary variables are set automatically
for ii = 1:NumberOfEndogenousVariables
  varname = deblank(M_.endo_names(ii,:));
  eval(['ys(' int2str(ii) ') = ' varname ';']);
end